Index: vfs/nfs/nfs_nqlease.c
===================================================================
RCS file: /cvs/src/sys/vfs/nfs/nfs_nqlease.c,v
retrieving revision 1.13
diff -u -r1.13 nfs_nqlease.c
--- vfs/nfs/nfs_nqlease.c	15 Nov 2003 21:05:44 -0000	1.13
+++ vfs/nfs/nfs_nqlease.c	22 Feb 2004 06:15:06 -0000
@@ -1081,7 +1081,7 @@
 			vp = NFSTOV(np);
 			vpid = vp->v_id;
 			if (np->n_expiry < time_second) {
-			   if (vget(vp, LK_EXCLUSIVE, td) == 0) {
+			   if (vget(vp, NULL, LK_EXCLUSIVE, td) == 0) {
 			     nmp->nm_inprog = vp;
 			     if (vpid == vp->v_id) {
 				CIRCLEQ_REMOVE(&nmp->nm_timerhead, np, n_timer);
@@ -1108,7 +1108,7 @@
 			    if ((np->n_flag & (NQNFSWRITE | NQNFSNONCACHE))
 				 == NQNFSWRITE &&
 				 !TAILQ_EMPTY(&vp->v_dirtyblkhd) &&
-				 vget(vp, LK_EXCLUSIVE, td) == 0) {
+				 vget(vp, NULL, LK_EXCLUSIVE, td) == 0) {
 				 nmp->nm_inprog = vp;
 				 if (vpid == vp->v_id &&
 				     nqnfs_getlease(vp, ND_WRITE, td)==0)
@@ -1176,6 +1176,7 @@
 	struct nfsnode *np;
 	struct mount *mp, *nxtmp;
 	struct nfsmount *nmp;
+	lwkt_tokref ilock;
 	int s;
 
 	if (nqnfsstarttime != 0)
@@ -1190,9 +1191,9 @@
 	 * Search the mount list for all nqnfs mounts and do their timer
 	 * queues.
 	 */
-	lwkt_gettoken(&mountlist_token);
+	lwkt_gettoken(&ilock, &mountlist_token);
 	for (mp = TAILQ_FIRST(&mountlist); mp != NULL; mp = nxtmp) {
-		if (vfs_busy(mp, LK_NOWAIT, &mountlist_token, td)) {
+		if (vfs_busy(mp, LK_NOWAIT, &ilock, td)) {
 			nxtmp = TAILQ_NEXT(mp, mnt_list);
 			continue;
 		}
@@ -1206,11 +1207,11 @@
 				}
 			}
 		}
-		lwkt_gettoken(&mountlist_token);
+		lwkt_gettokref(&ilock);
 		nxtmp = TAILQ_NEXT(mp, mnt_list);
 		vfs_unbusy(mp, td);
 	}
-	lwkt_reltoken(&mountlist_token);
+	lwkt_reltoken(&ilock);
 }
 
 #ifndef NFS_NOSERVER 
Index: vfs/nfs/nfs_serv.c
===================================================================
RCS file: /cvs/src/sys/vfs/nfs/nfs_serv.c,v
retrieving revision 1.12
diff -u -r1.12 nfs_serv.c
--- vfs/nfs/nfs_serv.c	30 Jan 2004 06:18:28 -0000	1.12
+++ vfs/nfs/nfs_serv.c	22 Feb 2004 05:58:05 -0000
@@ -529,7 +529,7 @@
 			 * via the original nd.  Confused?  You aren't alone!
 			 */
 			ind = nd;
-			VOP_UNLOCK(nd.ni_vp, 0, td);
+			VOP_UNLOCK(nd.ni_vp, NULL, 0, td);
 			ind.ni_pathlen = strlen(nfs_pub.np_index);
 			ind.ni_cnd.cn_nameptr = ind.ni_cnd.cn_pnbuf =
 			    nfs_pub.np_index;
@@ -3030,7 +3030,7 @@
 		error = 0;
 		goto nfsmout;
 	}
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 
 	/*
 	 * end section.  Allocate rbuf and continue
@@ -3047,7 +3047,7 @@
 	io.uio_rw = UIO_READ;
 	io.uio_td = NULL;
 	eofflag = 0;
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (cookies) {
 		free((caddr_t)cookies, M_TEMP);
 		cookies = NULL;
@@ -3061,7 +3061,7 @@
 		if (!error)
 			error = getret;
 	}
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (error) {
 		vrele(vp);
 		vp = NULL;
@@ -3315,7 +3315,7 @@
 		error = 0;
 		goto nfsmout;
 	}
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	MALLOC(rbuf, caddr_t, siz, M_TEMP, M_WAITOK);
 again:
 	iv.iov_base = rbuf;
@@ -3328,7 +3328,7 @@
 	io.uio_rw = UIO_READ;
 	io.uio_td = NULL;
 	eofflag = 0;
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (cookies) {
 		free((caddr_t)cookies, M_TEMP);
 		cookies = NULL;
@@ -3336,7 +3336,7 @@
 	error = VOP_READDIR(vp, &io, cred, &eofflag, &ncookies, &cookies);
 	off = (u_quad_t)io.uio_offset;
 	getret = VOP_GETATTR(vp, &at, td);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (!cookies && !error)
 		error = NFSERR_PERM;
 	if (!error)
Index: vfs/nfs/nfs_subs.c
===================================================================
RCS file: /cvs/src/sys/vfs/nfs/nfs_subs.c,v
retrieving revision 1.11
diff -u -r1.11 nfs_subs.c
--- vfs/nfs/nfs_subs.c	21 Dec 2003 12:34:08 -0000	1.11
+++ vfs/nfs/nfs_subs.c	22 Feb 2004 19:56:44 -0000
@@ -1651,7 +1651,7 @@
 		 * Validate symlink
 		 */
 		if ((cnp->cn_flags & CNP_LOCKPARENT) && ndp->ni_pathlen == 1)
-			VOP_UNLOCK(ndp->ni_dvp, 0, td);
+			VOP_UNLOCK(ndp->ni_dvp, NULL, 0, td);
 		if (!pubflag) {
 			error = EINVAL;
 			goto badlink2;
@@ -1990,7 +1990,7 @@
 	nfsrv_object_create(*vpp);
 
 	if (!lockflag)
-		VOP_UNLOCK(*vpp, 0, td);
+		VOP_UNLOCK(*vpp, NULL, 0, td);
 	return (0);
 }
 
@@ -2143,9 +2143,11 @@
 	s = splbio();
 loop:
 	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp; vp = nvp) {
+		nvp = TAILQ_NEXT(vp, v_nmntvnodes);	/* ZZZ */
+		if (vp->v_flag & VPLACEMARKER)
+			continue;
 		if (vp->v_mount != mp)	/* Paranoia */
 			goto loop;
-		nvp = TAILQ_NEXT(vp, v_nmntvnodes);
 		for (bp = TAILQ_FIRST(&vp->v_dirtyblkhd); bp; bp = nbp) {
 			nbp = TAILQ_NEXT(bp, b_vnbufs);
 			if (BUF_REFCNT(bp) == 0 &&
Index: vfs/nfs/nfs_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/nfs/nfs_vfsops.c,v
retrieving revision 1.12
diff -u -r1.12 nfs_vfsops.c
--- vfs/nfs/nfs_vfsops.c	24 Feb 2004 19:22:38 -0000	1.12
+++ vfs/nfs/nfs_vfsops.c	25 Feb 2004 18:12:25 -0000
@@ -945,7 +945,7 @@
 	/*
 	 * Lose the lock but keep the ref.
 	 */
-	VOP_UNLOCK(*vpp, 0, curthread);
+	VOP_UNLOCK(*vpp, NULL, 0, curthread);
 
 	return (0);
 bad:
@@ -1062,6 +1062,8 @@
 	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist);
 	     vp != NULL;
 	     vp = TAILQ_NEXT(vp, v_nmntvnodes)) {
+		if (vp->v_flag & VPLACEMARKER)	/* ZZZ */
+			continue;
 		/*
 		 * If the vnode that we are about to sync is no longer
 		 * associated with this mount point, start over.
@@ -1071,7 +1073,7 @@
 		if (VOP_ISLOCKED(vp, NULL) || TAILQ_EMPTY(&vp->v_dirtyblkhd) ||
 		    waitfor == MNT_LAZY)
 			continue;
-		if (vget(vp, LK_EXCLUSIVE, td))
+		if (vget(vp, NULL, LK_EXCLUSIVE, td))
 			goto loop;
 		error = VOP_FSYNC(vp, waitfor, td);
 		if (error)
Index: vfs/nfs/nfs_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/nfs/nfs_vnops.c,v
retrieving revision 1.18
diff -u -r1.18 nfs_vnops.c
--- vfs/nfs/nfs_vnops.c	8 Feb 2004 05:27:42 -0000	1.18
+++ vfs/nfs/nfs_vnops.c	22 Feb 2004 06:15:15 -0000
@@ -888,14 +888,14 @@
 			VREF(newvp);
 			error = 0;
 		} else if (flags & CNP_ISDOTDOT) {
-			VOP_UNLOCK(dvp, 0, td);
-			error = vget(newvp, LK_EXCLUSIVE, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
+			error = vget(newvp, NULL, LK_EXCLUSIVE, td);
 			if (!error && lockparent && (flags & CNP_ISLASTCN))
-				error = vn_lock(dvp, LK_EXCLUSIVE, td);
+				error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td);
 		} else {
-			error = vget(newvp, LK_EXCLUSIVE, td);
+			error = vget(newvp, NULL, LK_EXCLUSIVE, td);
 			if (!lockparent || error || !(flags & CNP_ISLASTCN))
-				VOP_UNLOCK(dvp, 0, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
 		}
 		if (!error) {
 			if (vpid == newvp->v_id) {
@@ -911,9 +911,9 @@
 			}
 			vput(newvp);
 			if (lockparent && dvp != newvp && (flags & CNP_ISLASTCN))
-				VOP_UNLOCK(dvp, 0, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
 		}
-		error = vn_lock(dvp, LK_EXCLUSIVE, td);
+		error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td);
 		*vpp = NULLVP;
 		if (error)
 			return (error);
@@ -958,20 +958,20 @@
 		m_freem(mrep);
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent)
-			VOP_UNLOCK(dvp, 0, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 		return (0);
 	}
 
 	if (flags & CNP_ISDOTDOT) {
-		VOP_UNLOCK(dvp, 0, td);
+		VOP_UNLOCK(dvp, NULL, 0, td);
 		error = nfs_nget(dvp->v_mount, fhp, fhsize, &np);
 		if (error) {
-			vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 			return (error);
 		}
 		newvp = NFSTOV(np);
 		if (lockparent && (flags & CNP_ISLASTCN) &&
-		    (error = vn_lock(dvp, LK_EXCLUSIVE, td))) {
+		    (error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td))) {
 		    	vput(newvp);
 			return (error);
 		}
@@ -985,7 +985,7 @@
 			return (error);
 		}
 		if (!lockparent || !(flags & CNP_ISLASTCN))
-			VOP_UNLOCK(dvp, 0, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 		newvp = NFSTOV(np);
 	}
 	if (v3) {
@@ -1011,7 +1011,7 @@
 		if ((cnp->cn_nameiop == NAMEI_CREATE || cnp->cn_nameiop == NAMEI_RENAME) &&
 		    (flags & CNP_ISLASTCN) && error == ENOENT) {
 			if (!lockparent)
-				VOP_UNLOCK(dvp, 0, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
 			if (dvp->v_mount->mnt_flag & MNT_RDONLY)
 				error = EROFS;
 			else
Index: vfs/ntfs/ntfs.h
===================================================================
RCS file: /cvs/src/sys/vfs/ntfs/ntfs.h,v
retrieving revision 1.3
diff -u -r1.3 ntfs.h
--- vfs/ntfs/ntfs.h	20 Aug 2003 09:56:33 -0000	1.3
+++ vfs/ntfs/ntfs.h	22 Feb 2004 06:15:20 -0000
@@ -314,9 +314,9 @@
 #define	LOCKMGR(a, b, c)	lockmgr((a), (b), (c))
 #else /* !NetBSD */
 #define HASHINIT(a, b, c, d)	hashinit((a), (b), (d))
-#define VOP__UNLOCK(a, b, c)	VOP_UNLOCK((a), (b), (c))
-#define VGET(a, b, c)		vget((a), (b), (c))
-#define VN_LOCK(a, b, c)	vn_lock((a), (b), (c))
+#define VOP__UNLOCK(a, b, c)	VOP_UNLOCK((a), NULL, (b), (c))
+#define VGET(a, b, c)		vget((a), NULL, (b), (c))
+#define VN_LOCK(a, b, c)	vn_lock((a), NULL, (b), (c))
 #define	LOCKMGR(a, b, c)	lockmgr((a), (b), (c), NULL)
 
 #endif /* NetBSD */
Index: vfs/ntfs/ntfs_ihash.c
===================================================================
RCS file: /cvs/src/sys/vfs/ntfs/ntfs_ihash.c,v
retrieving revision 1.7
diff -u -r1.7 ntfs_ihash.c
--- vfs/ntfs/ntfs_ihash.c	29 Dec 2003 18:04:59 -0000	1.7
+++ vfs/ntfs/ntfs_ihash.c	22 Feb 2004 07:20:24 -0000
@@ -70,7 +70,7 @@
 	lockinit(&ntfs_hashlock, 0, "ntfs_nthashlock", 0, 0);
 	ntfs_nthashtbl = HASHINIT(desiredvnodes, M_NTFSNTHASH, M_WAITOK,
 	    &ntfs_nthash);
-	lwkt_inittoken(&ntfs_nthash_slock);
+	lwkt_token_init(&ntfs_nthash_slock);
 }
 
 /*
@@ -79,10 +79,12 @@
 int
 ntfs_nthash_uninit(struct vfsconf *vfc)
 {
-	lwkt_gettoken(&ntfs_nthash_slock);
+	lwkt_tokref ilock;
+
+	lwkt_gettoken(&ilock, &ntfs_nthash_slock);
 	if (ntfs_nthashtbl)
 		free(ntfs_nthashtbl, M_NTFSNTHASH);
-	lwkt_reltoken(&ntfs_nthash_slock);
+	lwkt_reltoken(&ilock);
 
 	return 0;
 }
@@ -97,13 +99,14 @@
 	ino_t inum;
 {
 	struct ntnode *ip;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&ntfs_nthash_slock);
+	lwkt_gettoken(&ilock, &ntfs_nthash_slock);
 	for (ip = NTNOHASH(dev, inum)->lh_first; ip; ip = ip->i_hash.le_next) {
 		if (inum == ip->i_number && dev == ip->i_dev)
 			break;
 	}
-	lwkt_reltoken(&ntfs_nthash_slock);
+	lwkt_reltoken(&ilock);
 
 	return (ip);
 }
@@ -116,12 +119,13 @@
 	struct ntnode *ip;
 {
 	struct nthashhead *ipp;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&ntfs_nthash_slock);
+	lwkt_gettoken(&ilock, &ntfs_nthash_slock);
 	ipp = NTNOHASH(ip->i_dev, ip->i_number);
 	LIST_INSERT_HEAD(ipp, ip, i_hash);
 	ip->i_flag |= IN_HASHED;
-	lwkt_reltoken(&ntfs_nthash_slock);
+	lwkt_reltoken(&ilock);
 }
 
 /*
@@ -131,7 +135,9 @@
 ntfs_nthashrem(ip)
 	struct ntnode *ip;
 {
-	lwkt_gettoken(&ntfs_nthash_slock);
+	lwkt_tokref ilock;
+
+	lwkt_gettoken(&ilock, &ntfs_nthash_slock);
 	if (ip->i_flag & IN_HASHED) {
 		ip->i_flag &= ~IN_HASHED;
 		LIST_REMOVE(ip, i_hash);
@@ -140,5 +146,5 @@
 		ip->i_hash.le_prev = NULL;
 #endif
 	}
-	lwkt_reltoken(&ntfs_nthash_slock);
+	lwkt_reltoken(&ilock);
 }
Index: vfs/ntfs/ntfs_subr.c
===================================================================
RCS file: /cvs/src/sys/vfs/ntfs/ntfs_subr.c,v
retrieving revision 1.10
diff -u -r1.10 ntfs_subr.c
--- vfs/ntfs/ntfs_subr.c	5 Feb 2004 21:03:37 -0000	1.10
+++ vfs/ntfs/ntfs_subr.c	22 Feb 2004 07:20:26 -0000
@@ -356,12 +356,14 @@
 ntfs_ntget(ip)
 	struct ntnode *ip;
 {
+	lwkt_tokref ilock;
+
 	dprintf(("ntfs_ntget: get ntnode %d: %p, usecount: %d\n",
 		ip->i_number, ip, ip->i_usecount));
 
-	ip->i_usecount++;
-	lwkt_gettoken(&ip->i_interlock);
-	LOCKMGR(&ip->i_lock, LK_EXCLUSIVE | LK_INTERLOCK, &ip->i_interlock);
+	ip->i_usecount++;	/* ZZZ */
+	lwkt_gettoken(&ilock, &ip->i_interlock);
+	LOCKMGR(&ip->i_lock, LK_EXCLUSIVE | LK_INTERLOCK, &ilock);
 
 	return 0;
 }
@@ -409,7 +411,7 @@
 
 	/* init lock and lock the newborn ntnode */
 	lockinit(&ip->i_lock, 0, "ntnode", 0, LK_EXCLUSIVE);
-	lwkt_inittoken(&ip->i_interlock);
+	lwkt_token_init(&ip->i_interlock);
 	ntfs_ntget(ip);
 
 	ntfs_nthashins(ip);
@@ -435,11 +437,12 @@
 	struct ntnode *ip;
 {
 	struct ntvattr *vap;
+	lwkt_tokref ilock;
 
 	dprintf(("ntfs_ntput: rele ntnode %d: %p, usecount: %d\n",
 		ip->i_number, ip, ip->i_usecount));
 
-	lwkt_gettoken(&ip->i_interlock);
+	lwkt_gettoken(&ilock, &ip->i_interlock);
 	ip->i_usecount--;
 
 #ifdef DIAGNOSTIC
@@ -450,7 +453,7 @@
 #endif
 
 	if (ip->i_usecount > 0) {
-		LOCKMGR(&ip->i_lock, LK_RELEASE|LK_INTERLOCK, &ip->i_interlock);
+		LOCKMGR(&ip->i_lock, LK_RELEASE|LK_INTERLOCK, &ilock);
 		return;
 	}
 
@@ -465,7 +468,7 @@
 		LIST_REMOVE(vap,va_list);
 		ntfs_freentvattr(vap);
 	}
-	lwkt_reltoken(&ip->i_interlock);
+	lwkt_reltoken(&ilock);
 	vrele(ip->i_devvp);
 	FREE(ip, M_NTFSNTNODE);
 }
@@ -491,17 +494,19 @@
 ntfs_ntrele(ip)
 	struct ntnode *ip;
 {
+	lwkt_tokref ilock;
+
 	dprintf(("ntfs_ntrele: rele ntnode %d: %p, usecount: %d\n",
 		ip->i_number, ip, ip->i_usecount));
 
-	lwkt_gettoken(&ip->i_interlock);
+	lwkt_gettoken(&ilock, &ip->i_interlock);
 	ip->i_usecount--;
 
 	if (ip->i_usecount < 0) {
 		panic("ntfs_ntrele: ino: %d usecount: %d \n",
 		      ip->i_number,ip->i_usecount);
 	}
-	lwkt_reltoken(&ip->i_interlock);
+	lwkt_reltoken(&ilock);
 }
 
 /*
Index: vfs/ntfs/ntfs_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/ntfs/ntfs_vfsops.c,v
retrieving revision 1.12
diff -u -r1.12 ntfs_vfsops.c
--- vfs/ntfs/ntfs_vfsops.c	5 Feb 2004 21:03:37 -0000	1.12
+++ vfs/ntfs/ntfs_vfsops.c	22 Feb 2004 05:56:51 -0000
@@ -167,8 +167,9 @@
 	struct mount *mp;
 	extern struct vnode *rootvp;
 	struct thread *td = curthread;	/* XXX */
-	int error;
 	struct ntfs_args args;
+	lwkt_tokref ilock;
+	int error;
 
 	if (root_device->dv_class != DV_DISK)
 		return (ENODEV);
@@ -197,9 +198,9 @@
 		return (error);
 	}
 
-	lwkt_gettoken(&mountlist_token);
+	lwkt_gettoken(&ilock, &mountlist_token);
 	CIRCLEQ_INSERT_TAIL(&mountlist, mp, mnt_list);
-	lwkt_reltoken(&mountlist_token);
+	lwkt_reltoken(&ilock);
 	(void)ntfs_statfs(mp, &mp->mnt_stat, td);
 	vfs_unbusy(mp);
 	return (0);
@@ -983,6 +984,7 @@
 	ntfs_ntput(ip);
 
 	if (lkflags & LK_TYPE_MASK) {
+		KKASSERT((lkflags & LK_INTERLOCK) == 0);
 		error = VN_LOCK(vp, lkflags, td);
 		if (error) {
 			vput(vp);
Index: vfs/nullfs/null_subr.c
===================================================================
RCS file: /cvs/src/sys/vfs/nullfs/null_subr.c,v
retrieving revision 1.6
diff -u -r1.6 null_subr.c
--- vfs/nullfs/null_subr.c	28 Aug 2003 02:03:18 -0000	1.6
+++ vfs/nullfs/null_subr.c	22 Feb 2004 06:15:43 -0000
@@ -131,11 +131,11 @@
 			 * stuff, but we don't want to lock
 			 * the lower node.
 			 */
-			if (vget(vp, LK_EXCLUSIVE | LK_CANRECURSE, td)) {
+			if (vget(vp, NULL, LK_EXCLUSIVE | LK_CANRECURSE, td)) {
 				printf ("null_node_find: vget failed.\n");
 				goto loop;
 			}
-			VOP_UNLOCK(lowervp, 0, td);
+			VOP_UNLOCK(lowervp, NULL, 0, td);
 			return (vp);
 		}
 	}
@@ -219,7 +219,7 @@
 
 	lockmgr(&null_hashlock, LK_EXCLUSIVE, NULL, td);
 	vp->v_vnlock = lowervp->v_vnlock;
-	error = VOP_LOCK(vp, LK_EXCLUSIVE | LK_THISLAYER, td);
+	error = VOP_LOCK(vp, NULL, LK_EXCLUSIVE | LK_THISLAYER, td);
 	if (error)
 		panic("null_node_alloc: can't lock new vnode\n");
 
Index: vfs/nullfs/null_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/nullfs/null_vfsops.c,v
retrieving revision 1.6
diff -u -r1.6 null_vfsops.c
--- vfs/nullfs/null_vfsops.c	23 Sep 2003 05:03:53 -0000	1.6
+++ vfs/nullfs/null_vfsops.c	22 Feb 2004 05:58:37 -0000
@@ -118,7 +118,7 @@
 	 */
 	if ((mp->mnt_vnodecovered->v_op == null_vnodeop_p) &&
 		VOP_ISLOCKED(mp->mnt_vnodecovered, NULL)) {
-		VOP_UNLOCK(mp->mnt_vnodecovered, 0, td);
+		VOP_UNLOCK(mp->mnt_vnodecovered, NULL, 0, td);
 		isvnunlocked = 1;
 	}
 	/*
@@ -131,7 +131,7 @@
 	 * Re-lock vnode.
 	 */
 	if (isvnunlocked && !VOP_ISLOCKED(mp->mnt_vnodecovered, NULL))
-		vn_lock(mp->mnt_vnodecovered, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(mp->mnt_vnodecovered, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 	if (error)
 		return (error);
@@ -170,7 +170,7 @@
 	/*
 	 * Unlock the node (either the lower or the alias)
 	 */
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	/*
 	 * Make sure the node alias worked
 	 */
@@ -267,7 +267,7 @@
 		return (EDEADLK);
 	}
 #endif
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	*vpp = vp;
 	return 0;
 }
Index: vfs/nullfs/null_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/nullfs/null_vnops.c,v
retrieving revision 1.8
diff -u -r1.8 null_vnops.c
--- vfs/nullfs/null_vnops.c	9 Oct 2003 22:27:27 -0000	1.8
+++ vfs/nullfs/null_vnops.c	22 Feb 2004 07:37:21 -0000
@@ -315,7 +315,7 @@
 			*(vps_p[i]) = old_vps[i];
 #if 0
 			if (reles & VDESC_VP0_WILLUNLOCK)
-				VOP_UNLOCK(*(vps_p[i]), LK_THISLAYER, curproc);
+				VOP_UNLOCK(*(vps_p[i]), NULL, LK_THISLAYER, curproc);
 #endif
 			if (reles & VDESC_VP0_WILLRELE)
 				vrele(*(vps_p[i]));
@@ -388,7 +388,7 @@
 	 * tracked by underlying filesystem.
 	 */
 	if (cnp->cn_flags & CNP_PDIRUNLOCK)
-		VOP_UNLOCK(dvp, LK_THISLAYER, td);
+		VOP_UNLOCK(dvp, NULL, LK_THISLAYER, td);
 	if ((error == 0 || error == EJUSTRETURN) && lvp != NULL) {
 		if (ldvp == lvp) {
 			*ap->a_vpp = dvp;
@@ -575,6 +575,7 @@
 null_lock(ap)
 	struct vop_lock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct thread *a_td;
 	} */ *ap;
@@ -589,11 +590,11 @@
 		if (vp->v_vnlock != NULL) {
 			/* lock is shared across layers */
 			if (flags & LK_INTERLOCK)
-				lwkt_reltoken(&vp->v_interlock);
+				lwkt_reltoken(ap->a_vlock);
 			return 0;
 		}
 		error = lockmgr(&np->null_lock, flags & ~LK_THISLAYER,
-		    &vp->v_interlock, ap->a_td);
+		    ap->a_vlock, ap->a_td);
 		return (error);
 	}
 
@@ -610,9 +611,9 @@
 			NULLFSDEBUG("null_lock: avoiding LK_DRAIN\n");
 			return(lockmgr(vp->v_vnlock,
 				(flags & ~LK_TYPE_MASK) | LK_EXCLUSIVE,
-				&vp->v_interlock, ap->a_td));
+				ap->a_vlock, ap->a_td));
 		}
-		return(lockmgr(vp->v_vnlock, flags, &vp->v_interlock, ap->a_td));
+		return(lockmgr(vp->v_vnlock, flags, ap->a_vlock, ap->a_td));
 	}
 	/*
 	 * To prevent race conditions involving doing a lookup
@@ -624,21 +625,21 @@
 	 */
 	lvp = NULLVPTOLOWERVP(vp);
 	if (lvp == NULL)
-		return (lockmgr(&np->null_lock, flags, &vp->v_interlock, ap->a_td));
+		return (lockmgr(&np->null_lock, flags, ap->a_vlock, ap->a_td));
 	if (flags & LK_INTERLOCK) {
-		VI_UNLOCK(vp);
+		VI_UNLOCK(ap->a_vlock, vp);
 		flags &= ~LK_INTERLOCK;
 	}
 	if ((flags & LK_TYPE_MASK) == LK_DRAIN) {
-		error = VOP_LOCK(lvp,
+		error = VOP_LOCK(lvp, ap->a_vlock,
 			(flags & ~LK_TYPE_MASK) | LK_EXCLUSIVE, ap->a_td);
 	} else
-		error = VOP_LOCK(lvp, flags, ap->a_td);
+		error = VOP_LOCK(lvp, ap->a_vlock, flags, ap->a_td);
 	if (error)
 		return (error);
-	error = lockmgr(&np->null_lock, flags, &vp->v_interlock, ap->a_td);
+	error = lockmgr(&np->null_lock, flags, ap->a_vlock, ap->a_td);
 	if (error)
-		VOP_UNLOCK(lvp, 0, ap->a_td);
+		VOP_UNLOCK(lvp, NULL, 0, ap->a_td);
 	return (error);
 }
 
@@ -651,6 +652,7 @@
 null_unlock(ap)
 	struct vop_unlock_args /* {
 		struct vnode *a_vp;
+		lwkt_tokref_t a_vlock;
 		int a_flags;
 		struct thread *a_td;
 	} */ *ap;
@@ -665,21 +667,22 @@
 			return 0;	/* the lock is shared across layers */
 		flags &= ~LK_THISLAYER;
 		return (lockmgr(vp->v_vnlock, flags | LK_RELEASE,
-			&vp->v_interlock, ap->a_td));
+			ap->a_vlock, ap->a_td));
 	}
 	lvp = NULLVPTOLOWERVP(vp);
 	if (lvp == NULL)
-		return (lockmgr(&np->null_lock, flags | LK_RELEASE, &vp->v_interlock, ap->a_td));
+		return (lockmgr(&np->null_lock, flags | LK_RELEASE, ap->a_vlock, ap->a_td));
 	if ((flags & LK_THISLAYER) == 0) {
 		if (flags & LK_INTERLOCK) {
-			VI_UNLOCK(vp);
+			VI_UNLOCK(ap->a_vlock, vp);
 			flags &= ~LK_INTERLOCK;
 		}
-		VOP_UNLOCK(lvp, flags, ap->a_td);
-	} else
+		VOP_UNLOCK(lvp, ap->a_vlock, flags, ap->a_td);
+	} else {
 		flags &= ~LK_THISLAYER;
+	}
 	ap->a_flags = flags;
-	return (lockmgr(&np->null_lock, flags | LK_RELEASE, &vp->v_interlock, ap->a_td));
+	return (lockmgr(&np->null_lock, flags | LK_RELEASE, ap->a_vlock, ap->a_td));
 }
 
 static int
@@ -720,8 +723,9 @@
 	xp->null_lowervp = NULLVP;
 	if (vp->v_vnlock != NULL) {
 		vp->v_vnlock = &xp->null_lock;	/* we no longer share the lock */
-	} else
-		VOP_UNLOCK(vp, LK_THISLAYER, ap->a_td);
+	} else {
+		VOP_UNLOCK(vp, NULL, LK_THISLAYER, ap->a_td);
+	}
 
 	vput(lowervp);
 	/*
Index: vfs/nwfs/nwfs_node.c
===================================================================
RCS file: /cvs/src/sys/vfs/nwfs/nwfs_node.c,v
retrieving revision 1.9
diff -u -r1.9 nwfs_node.c
--- vfs/nwfs/nwfs_node.c	10 Nov 2003 06:12:17 -0000	1.9
+++ vfs/nwfs/nwfs_node.c	22 Feb 2004 19:07:26 -0000
@@ -140,17 +140,17 @@
 	struct nwnode_hash_head *nhpp;
 	struct nwmount *nmp = VFSTONWFS(mp);
 	struct vnode *vp;
+	lwkt_tokref vlock;
 	int error;
-	int gen;
 
 loop:
 	lockmgr(&nwhashlock, LK_EXCLUSIVE, NULL, td);
 rescan:
 	if (nwfs_hashlookup(nmp, fid, &np) == 0) {
 		vp = NWTOV(np);
-		gen = lwkt_gettoken(&vp->v_interlock);
+		lwkt_gettoken(&vlock, vp->v_interlock);
 		lockmgr(&nwhashlock, LK_RELEASE, NULL, td);
-		if (vget(vp, LK_EXCLUSIVE | LK_INTERLOCK, td))
+		if (vget(vp, &vlock, LK_EXCLUSIVE | LK_INTERLOCK, td))
 			goto loop;
 		*vpp = vp;
 		return(0);
@@ -190,7 +190,7 @@
 	lockinit(&np->n_lock, 0, "nwnode", VLKTIMEOUT, LK_CANRECURSE);
 	nhpp = NWNOHASH(fid);
 	LIST_INSERT_HEAD(nhpp, np, n_hash);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	lockmgr(&nwhashlock, LK_RELEASE, NULL, td);
 	return 0;
 }
@@ -268,7 +268,7 @@
 		error = ncp_close_file(NWFSTOCONN(VTONWFS(vp)), &np->n_fh, td, cred);
 		np->opened = 0;
 	}
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (np->n_flag & NSHOULDFREE) {
 		cache_purge(vp);
 		vgone(vp);
Index: vfs/nwfs/nwfs_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/nwfs/nwfs_vfsops.c,v
retrieving revision 1.8
diff -u -r1.8 nwfs_vfsops.c
--- vfs/nwfs/nwfs_vfsops.c	20 Jan 2004 05:04:07 -0000	1.8
+++ vfs/nwfs/nwfs_vfsops.c	22 Feb 2004 19:57:26 -0000
@@ -224,7 +224,7 @@
 	/*
 	 * Lose the lock but keep the ref.
 	 */
-	VOP_UNLOCK(vp, 0, curthread);
+	VOP_UNLOCK(vp, NULL, 0, curthread);
 	NCPVODEBUG("rootvp.vrefcnt=%d\n",vp->v_usecount);
 	return error;
 bad:
@@ -289,7 +289,7 @@
 	conn = NWFSTOCONN(nmp);
 	if (nmp->n_root) {
 		*vpp = NWTOV(nmp->n_root);
-		while (vget(*vpp, LK_EXCLUSIVE, curthread) != 0) /* XXX */
+		while (vget(*vpp, NULL, LK_EXCLUSIVE, curthread) != 0) /* XXX */
 			;
 		return 0;
 	}
@@ -494,6 +494,8 @@
 	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist);
 	     vp != NULL;
 	     vp = TAILQ_NEXT(vp, v_nmntvnodes)) {
+		if (vp->v_flag & VPLACEMARKER)	/* ZZZ */
+			continue;
 		/*
 		 * If the vnode that we are about to sync is no longer
 		 * associated with this mount point, start over.
@@ -503,7 +505,7 @@
 		if (VOP_ISLOCKED(vp, NULL) || TAILQ_EMPTY(&vp->v_dirtyblkhd) ||
 		    waitfor == MNT_LAZY)
 			continue;
-		if (vget(vp, LK_EXCLUSIVE, td))
+		if (vget(vp, NULL, LK_EXCLUSIVE, td))
 			goto loop;
 		error = VOP_FSYNC(vp, waitfor, td);
 		if (error)
Index: vfs/nwfs/nwfs_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/nwfs/nwfs_vnops.c,v
retrieving revision 1.9
diff -u -r1.9 nwfs_vnops.c
--- vfs/nwfs/nwfs_vnops.c	9 Oct 2003 22:27:27 -0000	1.9
+++ vfs/nwfs/nwfs_vnops.c	22 Feb 2004 19:07:29 -0000
@@ -242,30 +242,31 @@
 {
 	struct vnode *vp = ap->a_vp;
 	struct nwnode *np = VTONW(vp);
+	lwkt_tokref vlock;
 	int error;
 
 	NCPVNDEBUG("name=%s,td=%p,c=%d\n",np->n_name,ap->a_td,np->opened);
 
 	if (vp->v_type == VDIR) return 0;	/* nothing to do now */
 	error = 0;
-	lwkt_gettoken(&vp->v_interlock);
+	lwkt_gettoken(&vlock, vp->v_interlock);
 	if (np->opened == 0) {
-		lwkt_reltoken(&vp->v_interlock);
+		lwkt_reltoken(&vlock);
 		return 0;
 	}
-	lwkt_reltoken(&vp->v_interlock);
+	lwkt_reltoken(&vlock);
 	error = nwfs_vinvalbuf(vp, V_SAVE, ap->a_td, 1);
-	lwkt_gettoken(&vp->v_interlock);
+	lwkt_gettokref(&vlock);
 	if (np->opened == 0) {
-		lwkt_reltoken(&vp->v_interlock);
+		lwkt_reltoken(&vlock);
 		return 0;
 	}
 	if (--np->opened == 0) {
-		lwkt_reltoken(&vp->v_interlock);
+		lwkt_reltoken(&vlock);
 		error = ncp_close_file(NWFSTOCONN(VTONWFS(vp)), &np->n_fh, 
 		   ap->a_td, proc0.p_ucred);
 	} else {
-		lwkt_reltoken(&vp->v_interlock);
+		lwkt_reltoken(&vlock);
 	}
 	np->n_atime = 0;
 	return (error);
@@ -960,14 +961,14 @@
 			error = 0;
 			NCPVNDEBUG("cached '.'");
 		} else if (flags & CNP_ISDOTDOT) {
-			VOP_UNLOCK(dvp, 0, td);	/* unlock parent */
-			error = vget(vp, LK_EXCLUSIVE, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);	/* unlock parent */
+			error = vget(vp, NULL, LK_EXCLUSIVE, td);
 			if (!error && lockparent && islastcn)
-				error = vn_lock(dvp, LK_EXCLUSIVE, td);
+				error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td);
 		} else {
-			error = vget(vp, LK_EXCLUSIVE, td);
+			error = vget(vp, NULL, LK_EXCLUSIVE, td);
 			if (!lockparent || error || !islastcn)
-				VOP_UNLOCK(dvp, 0, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
 		}
 		if (!error) {
 			if (vpid == vp->v_id) {
@@ -982,9 +983,9 @@
 			}
 			vput(vp);
 			if (lockparent && dvp != vp && islastcn)
-				VOP_UNLOCK(dvp, 0, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
 		}
-		error = vn_lock(dvp, LK_EXCLUSIVE, td);
+		error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td);
 		*vpp = NULLVP;
 		if (error)
 			return (error);
@@ -1027,7 +1028,7 @@
 		if ((nameiop == NAMEI_CREATE || nameiop == NAMEI_RENAME) && wantparent && islastcn) {
 			cnp->cn_flags |= CNP_SAVENAME;
 			if (!lockparent)
-				VOP_UNLOCK(dvp, 0, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
 			return (EJUSTRETURN);
 		}
 		return ENOENT;
@@ -1047,7 +1048,7 @@
 		if (error) return (error);
 		*vpp = vp;
 		cnp->cn_flags |= CNP_SAVENAME;	/* I free it later */
-		if (!lockparent) VOP_UNLOCK(dvp,0,td);
+		if (!lockparent) VOP_UNLOCK(dvp, NULL, 0, td);
 		return (0);
 	}
 	if (nameiop == NAMEI_RENAME && islastcn && wantparent) {
@@ -1059,18 +1060,18 @@
 		*vpp = vp;
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent)
-			VOP_UNLOCK(dvp,0,td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 		return (0);
 	}
 	if (flags & CNP_ISDOTDOT) {
-		VOP_UNLOCK(dvp, 0, td);		/* race to get the inode */
+		VOP_UNLOCK(dvp, NULL, 0, td);	/* race to get the inode */
 		error = nwfs_nget(mp, fid, NULL, NULL, &vp);
 		if (error) {
-			vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 			return (error);
 		}
 		if (lockparent && islastcn &&
-		    (error = vn_lock(dvp, LK_EXCLUSIVE, td))) {
+		    (error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td))) {
 		    	vput(vp);
 			return (error);
 		}
@@ -1084,7 +1085,7 @@
 		*vpp = vp;
 		NCPVNDEBUG("lookup: getnewvp!\n");
 		if (!lockparent || !islastcn)
-			VOP_UNLOCK(dvp, 0, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 	}
 	if ((cnp->cn_flags & CNP_MAKEENTRY)/* && !islastcn*/) {
 		VTONW(*vpp)->n_ctime = VTONW(*vpp)->n_vattr.va_ctime.tv_sec;
Index: vfs/portal/portal_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/portal/portal_vfsops.c,v
retrieving revision 1.5
diff -u -r1.5 portal_vfsops.c
--- vfs/portal/portal_vfsops.c	20 Aug 2003 09:56:33 -0000	1.5
+++ vfs/portal/portal_vfsops.c	22 Feb 2004 05:59:01 -0000
@@ -210,7 +210,7 @@
 	 */
 	vp = VFSTOPORTAL(mp)->pm_root;
 	VREF(vp);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	*vpp = vp;
 	return (0);
 }
Index: vfs/portal/portal_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/portal/portal_vnops.c,v
retrieving revision 1.8
diff -u -r1.8 portal_vnops.c
--- vfs/portal/portal_vnops.c	23 Sep 2003 05:03:53 -0000	1.8
+++ vfs/portal/portal_vnops.c	22 Feb 2004 05:44:25 -0000
@@ -537,7 +537,7 @@
 	} */ *ap;
 {
 
-	VOP_UNLOCK(ap->a_vp, 0, ap->a_td);
+	VOP_UNLOCK(ap->a_vp, NULL, 0, ap->a_td);
 	return (0);
 }
 
Index: vfs/procfs/procfs_subr.c
===================================================================
RCS file: /cvs/src/sys/vfs/procfs/procfs_subr.c,v
retrieving revision 1.5
diff -u -r1.5 procfs_subr.c
--- vfs/procfs/procfs_subr.c	7 Aug 2003 21:17:43 -0000	1.5
+++ vfs/procfs/procfs_subr.c	22 Feb 2004 06:16:13 -0000
@@ -98,7 +98,7 @@
 		if (pfs->pfs_pid == pid &&
 		    pfs->pfs_type == pfs_type &&
 		    vp->v_mount == mp) {
-			if (vget(vp, 0, td))
+			if (vget(vp, NULL, 0, td))
 				goto loop;
 			*vpp = vp;
 			return (0);
Index: vfs/procfs/procfs_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/procfs/procfs_vnops.c,v
retrieving revision 1.10
diff -u -r1.10 procfs_vnops.c
--- vfs/procfs/procfs_vnops.c	23 Sep 2003 05:03:53 -0000	1.10
+++ vfs/procfs/procfs_vnops.c	22 Feb 2004 05:59:06 -0000
@@ -363,7 +363,7 @@
 {
 	struct vnode *vp = ap->a_vp;
 
-	VOP_UNLOCK(vp, 0, ap->a_td);
+	VOP_UNLOCK(vp, NULL, 0, ap->a_td);
 
 	return (0);
 }
@@ -717,7 +717,7 @@
 	if (cnp->cn_namelen == 1 && *pname == '.') {
 		*vpp = dvp;
 		VREF(dvp);
-		/* vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, curp); */
+		/* vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, curp); */
 		return (0);
 	}
 
Index: vfs/smbfs/smbfs_io.c
===================================================================
RCS file: /cvs/src/sys/vfs/smbfs/smbfs_io.c,v
retrieving revision 1.9
diff -u -r1.9 smbfs_io.c
--- vfs/smbfs/smbfs_io.c	10 Nov 2003 06:12:17 -0000	1.9
+++ vfs/smbfs/smbfs_io.c	22 Feb 2004 05:59:14 -0000
@@ -205,10 +205,10 @@
 	if (vp->v_type == VDIR) {
 		lks = LK_EXCLUSIVE;/*lockstatus(&vp->v_lock, td);*/
 		if (lks == LK_SHARED)
-			vn_lock(vp, LK_UPGRADE | LK_RETRY, td);
+			vn_lock(vp, NULL, LK_UPGRADE | LK_RETRY, td);
 		error = smbfs_readvdir(vp, uiop, cred);
 		if (lks == LK_SHARED)
-			vn_lock(vp, LK_DOWNGRADE | LK_RETRY, td);
+			vn_lock(vp, NULL, LK_DOWNGRADE | LK_RETRY, td);
 		return error;
 	}
 
